#encoding:utf-8
require 'java'
require 'svnkit/svnkit-1.8.5.jar'
require 'svnkit/sqljet-1.1.10.jar'
require 'svnkit/antlr-runtime-3.4.jar'
require 'svnkit/sequence-library-1.0.2.jar'
['org.tmatesoft.svn.core.wc.SVNClientManager',
'org.tmatesoft.svn.core.auth.BasicAuthenticationManager',
'org.tmatesoft.svn.core.wc.ISVNOptions',
'org.tmatesoft.svn.core.wc.SVNWCUtil',
'org.tmatesoft.svn.core.SVNURL',
'org.tmatesoft.svn.core.SVNDepth',
'org.tmatesoft.svn.core.wc.SVNUpdateClient',
'org.tmatesoft.svn.core.wc.SVNCopySource',
'org.tmatesoft.svn.core.wc.SVNRevision',
'org.tmatesoft.svn.core.SVNProperties',
'org.tmatesoft.svn.core.wc.SVNInfo',
'org.tmatesoft.svn.core.ISVNLogEntryHandler',
'org.tmatesoft.svn.core.internal.io.svn.SVNRepositoryFactoryImpl'].each do |klass|
	java_import klass
end
java_import('java.io.File') do |a,b|
	'JavaFile'
end

class Java::OrgTmatesoftSvnCoreWc::SVNInfo
	def last_revsion 
		getCommittedRevision.getNumber
	end
	def last_author 
		getAuthor
	end
end

class SVN
	attr_accessor :client
	def initialize user,password
		SVNRepositoryFactoryImpl.setup
		authormanager = BasicAuthenticationManager.new  user,password
		options = SVNWCUtil.createDefaultOptions(true)
		@client = SVNClientManager.newInstance(options,authormanager)
	end
	def checkout  svnurl,des
		url = SVNURL.parseURIEncoded svnurl
		#respository = @client.createRepository url,true
		#revision =  respository.getLatestRevision 
		#depth = SVNDepth.getInfinityOrEmptyDepth true
		desFile = JavaFile.new des
		updateclient = @client.getUpdateClient
		updateclient.setIgnoreExternals false
		updateclient.doCheckout(url, desFile, SVNRevision::HEAD, SVNRevision::HEAD, SVNDepth::INFINITY,true)
	end

	def copy svnurls,desturl,message='copy operation by svnkit'
		copyclient = @client.getCopyClient
		copyclient.setIgnoreExternals false
		    des=SVNURL.parseURIEncoded desturl
		    copysources=[]
		    svnurls.each do |svnurl|
			url =SVNURL.parseURIEncoded svnurl
			copysources << SVNCopySource.new(SVNRevision::HEAD, SVNRevision::HEAD, url)
		    end
		    copyclient.doCopy(copysources.to_java("org.tmatesoft.svn.core.wc.SVNCopySource"), des, false, true, false, message, nil)
	end
	    
	def upload svnurl,targetfile,message='import operation by svnkit'
		commitclient = @client.getCommitClient
		commitclient.setIgnoreExternals false
		url = SVNURL.parseURIEncoded svnurl
		target = JavaFile.new targetfile
		commitclient.doImport(target,url,message, nil, true, false,SVNDepth::INFINITY)
	end
	def delete svnurl,message='delete operation by svnkit'
		commitclient = @client.getCommitClient
		commitclient.setIgnoreExternals false
		url =SVNURL.parseURIEncoded svnurl
		deleteurls = []
		deleteurls << url
		commitclient.doDelete(deleteurls.to_java("org.tmatesoft.svn.core.SVNURL"), message)
	end
	
	def mkdir svnurl,message='mkdir operation by svnkit'
		commitclient = @client.getCommitClient
		commitclient.setIgnoreExternals false
		url = SVNURL.parseURIEncoded svnurl
		mkurls = []
		mkurls << url
		commitclient.doMkDir(mkurls.to_java("org.tmatesoft.svn.core.SVNURL"),message)
	end
	
	def export svnurl,despath,message='download(without svn manager)operation by svnkit'
		updateclient = @client.getUpdateClient
		updateclient.setIgnoreExternals false
		url =SVNURL.parseURIEncoded svnurl
		des = File.new despath
                updateclient.doExport(url,des, SVNRevision::HEAD, SVNRevision::HEAD, message,true,SVNDepth::INFINITY)
	end
	
	def update targetpath
		updateclient = @client.getUpdateClient
		updateclient.setIgnoreExternals false
		target = JavaFile.new targetpath
                updateclient.doUpdate(target, SVNRevision::HEAD,SVNDepth::INFINITY,true, true)
	end
	
	def wcclient
		@svnwcclient = @client.getWCClient unless @svnwcclient
		@svnwcclient.setIgnoreExternals false
	end
	
	def svninfo svnurl
		wcclient
		url =SVNURL.parseURIEncoded svnurl
		info = @svnwcclient.doInfo(url, SVNRevision::HEAD, SVNRevision::HEAD)
	end 
	
	def log svnurl,startRevision=nil,endRevision=nil
		repository = @client.createRepository(SVNURL.parseURIEncoded(svnurl),false)
		endRevision = repository.getLatestRevision unless endRevision
		startRevision = 0 unless startRevision
		logEntries = repository.log([].to_java("java.lang.String"), nil,startRevision, endRevision, true, true)
		logs=[]
		logEntries.iterator.each do |entry|
			p entry.java_class
			log={}
			log['revision'] = entry.getRevision
			log['author'] = entry.getAuthor
			log['date'] = entry.getDate.format
			log['message'] = entry.getMessage
			log['changepaths'] = []
			entry.getChangedPaths.keySet.iterator.each do |changepath|
				entryPath = entry.getChangedPaths.get changepath
				p entryPath.getType.chr
				p entryPath.getPath.to_s
				log['changepaths']<<{entryPath.getPath.to_s=>entryPath.getType.chr}
			end
			logs<<log
		end
		logs
	end
	
end
begin
	#svn = SVN.new 'chwu','qingqing923!'
	#svn.delete  "https://192.168.75.168:8888/svn/QM_CITI2.0/Tags/Build_1.2.15"
	#svn.mkdir "https://192.168.75.168:8888/svn/QM_CITI1.0/Trunk/Development/Source/test","test"
	#svn.checkout("https://192.168.75.168:8888/svn/QM_CITI1.0/Trunk/Project/06.Test/项目实施/标准环境/CustomCI V1.1",'E:\\RubyProject\\SVNKIT\\CIManager\\')
	#info =  svn.copy(["https://192.168.75.168:8888/svn/QM_CITI2.0/Trunk/Development/Source/CIManager",
	#"https://192.168.75.168:8888/svn/QM_CITI2.0/Trunk/Development/Source/svnkit",
	#"https://192.168.75.168:8888/svn/QM_CITI2.0/Trunk/Development/Source/CIManager"].uniq,
	#"https://192.168.75.168:8888/svn/QM_CITI2.0/Tags/Build_1.2.15") 
	#p info.getAuthor
	#p info.getDate
	#p info.getNewRevision
	#p revsion = svn.svninfo("https://192.168.75.168:8888/svn/QM_CITI2.0/Trunk/Development/Source/CIManager").last_revsion
	#svn.upload("https://192.168.75.168:8888/svn/QM_CITI1.0/Trunk/Development/Source/CIManager/dk.rb","C:\\dk.rb")
	#svn.delete "https://192.168.75.168:8888/svn/QM_CITI1.0/Trunk/Development/Source/CIManager/dk.rb"
	#svn.export "https://192.168.75.168:8888/svn/QM_CITI1.0/Trunk/Development/Source/CIManager/","F:\\"
	#svn.update "E:\\QM_CITI1.0\\项目实施\\标准环境"
end

#p svn.log "https://192.168.75.168:8888/svn/QM_CITI2.0/Trunk/Development/Source/CIManager",50,56

	